
#ifndef RISCOS

#include "stdafx.h"

#endif


#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <ctype.h>
#include "rtftype.h"
#include "rtfdecl.h"

#include "deb.h"

// RTF parser tables

// Property descriptions

PROP rgprop [ipropMax] = {
    actnByte,   propChp,    offsetof(CHP, fBold),       // ipropBold
    actnByte,   propChp,    offsetof(CHP, fItalic),     // ipropItalic
    actnByte,   propChp,    offsetof(CHP, fUnderline),  // ipropUnderline
    actnWord,   propPap,    offsetof(PAP, xaLeft),      // ipropLeftInd
    actnWord,   propPap,    offsetof(PAP, xaRight),     // ipropRightInd
    actnWord,   propPap,    offsetof(PAP, xaFirst),     // ipropFirstInd
    actnWord,   propSep,    offsetof(SEP, cCols),       // ipropCols
    actnWord,   propSep,    offsetof(SEP, xaPgn),       // ipropPgnX
    actnWord,   propSep,    offsetof(SEP, yaPgn),       // ipropPgnY
    actnWord,   propDop,    offsetof(DOP, xaPage),      // ipropXaPage
    actnWord,   propDop,    offsetof(DOP, yaPage),      // ipropYaPage
    actnWord,   propDop,    offsetof(DOP, xaLeft),      // ipropXaLeft
    actnWord,   propDop,    offsetof(DOP, xaRight),     // ipropXaRight
    actnWord,   propDop,    offsetof(DOP, yaTop),       // ipropYaTop
    actnWord,   propDop,    offsetof(DOP, yaBottom),    // ipropYaBottom
    actnWord,   propDop,    offsetof(DOP, pgnStart),    // ipropPgnStart
    actnByte,   propSep,    offsetof(SEP, sbk),         // ipropSbk
    actnByte,   propSep,    offsetof(SEP, pgnFormat),   // ipropPgnFormat
    actnByte,   propDop,    offsetof(DOP, fFacingp),    // ipropFacingp
    actnByte,   propDop,    offsetof(DOP, fLandscape),  // ipropLandscape
    actnByte,   propPap,    offsetof(PAP, just),        // ipropJust
    actnSpec,   propPap,    0,                          // ipropPard
    actnSpec,   propChp,    0,                          // ipropPlain
    actnSpec,   propSep,    0,                          // ipropSectd
    actnWord,   propChp,    offsetof(CHP, font),        // ipropFont
    actnByte,   propChp,    offsetof(CHP, caps),        // ipropCaps
    actnByte,   propPap,    offsetof(PAP, pagebreak),   // ipropPageBreak
    actnByte,   propChp,    offsetof(CHP, supersub),    // ipropSuperSub
    actnByte,   propPap,    offsetof(PAP, hpzone),      // ipropHpZone
    actnByte,   propPap,    offsetof(PAP, hpconsec),    // ipropHpConsec
    actnByte,   propPap,    offsetof(PAP, hpcaps),      // ipropHpCaps
    actnByte,   propPap,    offsetof(PAP, hpauto),      // ipropHpAuto
    actnWord,   propChp,    offsetof(CHP, fontsize),    // ipropFontSize
    actnWord,   propChp,    offsetof(CHP, unicoden),    // ipropunicoden
    actnSpec,   propChp,    0,                          // ipropCStyle
    actnSpec,   propPap,    0,                          // ipropPStyle
    actnSpec,   propSep,    0,                          // ipropSStyle

};


// Keyword descriptions
SYM rgsymRtf[] = 
{
//  keyword     dflt    fPassDflt   kwd         idx
    "b",        1,      fFalse,     kwdProp,    ipropBold,
    "i",        1,      fFalse,     kwdProp,    ipropItalic,
    "li",       0,      fFalse,     kwdProp,    ipropLeftInd,
    "ri",       0,      fFalse,     kwdProp,    ipropRightInd,
    "fi",       0,      fFalse,     kwdProp,    ipropFirstInd,
    "cols",     1,      fFalse,     kwdProp,    ipropCols,
    "sbknone",  sbkNon, fTrue,      kwdProp,    ipropSbk,
    "sbkcol",   sbkCol, fTrue,      kwdProp,    ipropSbk,
    "sbkeven",  sbkEvn, fTrue,      kwdProp,    ipropSbk,
    "sbkodd",   sbkOdd, fTrue,      kwdProp,    ipropSbk,
    "sbkpage",  sbkPg,  fTrue,      kwdProp,    ipropSbk,
    "pgnx",     0,      fFalse,     kwdProp,    ipropPgnX,
    "pgny",     0,      fFalse,     kwdProp,    ipropPgnY,
    "pgndec",   pgDec,  fTrue,      kwdProp,    ipropPgnFormat,
    "pgnucrm",  pgURom, fTrue,      kwdProp,    ipropPgnFormat,
    "pgnlcrm",  pgLRom, fTrue,      kwdProp,    ipropPgnFormat,
    "pgnucltr", pgULtr, fTrue,      kwdProp,    ipropPgnFormat,
    "pgnlcltr", pgLLtr, fTrue,      kwdProp,    ipropPgnFormat,
    "qc",       justC,  fTrue,      kwdProp,    ipropJust,
    "ql",       justL,  fTrue,      kwdProp,    ipropJust,
    "qr",       justR,  fTrue,      kwdProp,    ipropJust,
    "qj",       justF,  fTrue,      kwdProp,    ipropJust,
    "paperw",   12240,  fFalse,     kwdProp,    ipropXaPage,
    "paperh",   15480,  fFalse,     kwdProp,    ipropYaPage,
    "margl",    1800,   fFalse,     kwdProp,    ipropXaLeft,
    "margr",    1800,   fFalse,     kwdProp,    ipropXaRight,
    "margt",    1440,   fFalse,     kwdProp,    ipropYaTop,
    "margb",    1440,   fFalse,     kwdProp,    ipropYaBottom,
    "pgnstart", 1,      fTrue,      kwdProp,    ipropPgnStart,
    "facingp",  1,      fTrue,      kwdProp,    ipropFacingp,
    "landscape",1,      fTrue,      kwdProp,    ipropLandscape,

    "f",        0,      fFalse,     kwdProp,    ipropFont,
    "caps",     0,      fFalse,     kwdProp,    ipropCaps,
    "pagebb",   0,      fFalse,     kwdProp,    ipropPageBreak,
    "nosupersub",0,     fTrue,      kwdProp,    ipropSuperSub,
    "super",    1,      fTrue,      kwdProp,    ipropSuperSub,
    "sub",      2,      fTrue,      kwdProp,    ipropSuperSub,
    "up",       0,      fFalse,     kwdProp,    ipropSuperSub, // Superscript position in half-points (the default is 6).
    "dn",       0,      fFalse,     kwdProp,    ipropSuperSub, // Subscript position in half-points (the default is 6).

//    "u",        1,      fFalse,     kwdProp,    ipropUnderline,    
    "ul",       1,      fFalse,     kwdProp,    ipropUnderline, // Continuous underline.
    "ulc",      0,      fFalse,     kwdProp,    ipropUnderline, // underline colour N
    "uldb",     0,      fFalse,     kwdProp,    ipropUnderline, // Double underline.
    "uld",      0,      fFalse,     kwdProp,    ipropUnderline, // Dotted underline.
    "ulw",      0,      fFalse,     kwdProp,    ipropUnderline, // Word underline.
    "ulnone",   0,      fFalse,     kwdProp,    ipropUnderline, //  Stops all underlining.
    "uldash",   0,      fFalse,     kwdProp,    ipropUnderline, // Dashed underline
    "uldashd",  0,      fFalse,     kwdProp,    ipropUnderline, // Dash-dotted underline.
    "uldashdd", 0,      fFalse,     kwdProp,    ipropUnderline, // Dash-dot-dotted underline. 
    "ulhwave",  0,      fFalse,     kwdProp,    ipropUnderline, // Heavy wave underline.
    "ulldash",  0,      fFalse,     kwdProp,    ipropUnderline, // Long dashed underline.
    "ulth",     0,      fFalse,     kwdProp,    ipropUnderline, // Thick underline.
    "ulthd",    0,      fFalse,     kwdProp,    ipropUnderline, // Thick dotted underline.
    "ulthdash", 0,      fFalse,     kwdProp,    ipropUnderline, // Thick dashed underline.
    "ulthdashd",0,      fFalse,     kwdProp,    ipropUnderline, // Thick dash-dotted underline.
    "ulthdashdd",0,     fFalse,     kwdProp,    ipropUnderline, // Thick dash-dot-dotted underline.
    "ulthldash", 0,     fFalse,     kwdProp,    ipropUnderline, // Thick long dashed underline.
    "ululdbwave",0,     fFalse,     kwdProp,    ipropUnderline, // Double wave underline.
    "ulwave",   0,      fFalse,     kwdProp,    ipropUnderline, // Wave underline.

    "hyphhotz", 0,      fFalse,     kwdProp,    ipropHpZone,  // Hyphenation hot zone in twips (the amount of space at the right margin in which words are hyphenated).
    "hyphconsec",0,     fFalse,     kwdProp,    ipropHpConsec,// N is the maximum number of consecutive lines that will be allowed to end in a hyphen. 0 means no limit.
    "hyphcaps", 0,      fFalse,     kwdProp,    ipropHpCaps,  // Toggles hyphenation of capitalized words (the default is on). Append 1 or leave control word by itself to toggle property on; append 0 to turn it off.
    "hyphauto", 0,      fFalse,     kwdProp,    ipropHpAuto,  // Toggles automatic hyphenation (the default is off). Append 1 or leave control word by itself to toggle property on; append 0 to turn it o
    "fs",       0,      fFalse,     kwdProp,    ipropFontSize,// Font size in half-points (the default is 24).
				"uc",	      0,      fFalse,     kwdProp,    ipropunicoden,// Unicode skip count (default 1).


    "pard",     0,      fFalse,     kwdProp,    ipropPard,
    "plain",    0,      fFalse,     kwdProp,    ipropPlain,  // Reset font (character) formatting properties to a default value defined by the application (for example, bold, underline and italic are disabled; font size is reset to 12 point). The associated font (character) formatting properties (described in the section Associated Character Properties of this Specification) are also reset
    "sectd",    0,      fFalse,     kwdProp,    ipropSectd,
    
    "cs",       0,      fFalse,     kwdStyle,   ipropCStyle,
    "s",        0,      fFalse,     kwdStyle,   ipropPStyle,
    "ds",       0,      fFalse,     kwdStyle,   ipropSStyle,
    "sbasedon",222,     fFalse,     kwdStyle,   ipropBasedon,
    "additive", 0,      fFalse,     kwdStyle,   ipropAdditive,


//    "slmult",

    "fnil",     fnil,   fTrue,      kwdFont,    ipropFontFamily,
    "froman",   froman, fTrue,      kwdFont,    ipropFontFamily,
    "fswiss",   fswiss, fTrue,      kwdFont,    ipropFontFamily,
    "fmodern",  fmodern,fTrue,      kwdFont,    ipropFontFamily,
    "fscript",  fscript,fTrue,      kwdFont,    ipropFontFamily,
    "fdecor",   fdecor, fTrue,      kwdFont,    ipropFontFamily,
    "ftech",    ftech,  fTrue,      kwdFont,    ipropFontFamily,
    "fbidi",    fbidi,  fTrue,      kwdFont,    ipropFontFamily,
               
    "red",      0,      fFalse,     kwdColour,  ipropColourRed,
    "green",    0,      fFalse,     kwdColour,  ipropColourGreen,
    "blue",     0,      fFalse,     kwdColour,  ipropColourBlue,

    "tx",       0,      fFalse,     kwdTabs,    ipropTabs,//  Tab position in twips from the left margin.
    "tqr",      0,      fFalse,     kwdTabs,    ipropTabs,// Flush-right tab.
    "tqc",      0,      fFalse,     kwdTabs,    ipropTabs,// Centered tab.
    "tqdec",    0,      fFalse,     kwdTabs,    ipropTabs,// Decimal tab.
    "tb",       0,      fFalse,     kwdTabs,    ipropTabs,// Bar tab position in twips from the left margin.
    "tldot",    0,      fFalse,     kwdTabs,    ipropTabs,// Leader dots.
    "tlmdot",   0,      fFalse,     kwdTabs,    ipropTabs,// Leader middle dots.
    "tlhyph",   0,      fFalse,     kwdTabs,    ipropTabs,// Leader hyphens.
    "tlul",     0,      fFalse,     kwdTabs,    ipropTabs,// Leader underline.
    "tlth",     0,      fFalse,     kwdTabs,    ipropTabs,// Leader thick line.
    "tleq",     0,      fFalse,     kwdTabs,    ipropTabs,// Leader equal sign.
    "deftab",   0,      fFalse,     kwdTabs,    ipropTabs,// default tab width in twips


    "rtf",      0,      fFalse,   kwdSystem,    ipropRTF,
    "ansi",     0,      fFalse,   kwdSystem,    ipropANSI,// ANSI (the default)
    "mac",      0,      fFalse,   kwdSystem,    ipropMac, // Apple Macintosh
    "pc",       0,      fFalse,   kwdSystem,    ipropPC,  // IBM PC code page 437
    "pca",      0,      fFalse,   kwdSystem,    ipropPCA, //IBM PC code page 850, used by IBM Personal System/2 (not implemented in version 1 of Microsoft Word for OS/2)
    "deff",     0,      fFalse,   kwdSystem,    ipropDefFont,
    

    "emfblip",  0,      fFalse,   kwdPict,      ipropPictemf,
    "pngblip",  0,      fFalse,   kwdPict,      ipropPictpng,
    "jpegblip", 0,      fFalse,   kwdPict,      ipropPictjpeg,
    "wmetafile",1,      fTrue,    kwdPict,      ipropPictwmf,

    "picw",     0,      fFalse,   kwdPict,      ipropPictpixwidth,
    "pich",     0,      fFalse,   kwdPict,      ipropPictpixheight,
    "picwgoal", 0,      fFalse,   kwdPict,      ipropPicttwipwidth,
    "pichgoal", 0,      fFalse,   kwdPict,      ipropPicttwipheight,
    "picscalex",100,    fFalse,   kwdPict,      ipropPictxscale,
    "picscaley",100,    fFalse,   kwdPict,      ipropPictyscale,
    "picscaled",0,      fFalse,   kwdPict,      ipropPictfit,
    "piccropt", 0,      fTrue,    kwdPict,      ipropPictcroptop,
    "piccropb", 0,      fTrue,    kwdPict,      ipropPictcropbot,
    "piccropl", 0,      fTrue,    kwdPict,      ipropPictcropleft,
    "piccropr", 0,      fTrue,    kwdPict,      ipropPictcropright,
    "picbmp",   0,      fFalse,   kwdPict,      ipropPictmetabitmap,
    "picbpp",   1,      fTrue,    kwdPict,      ipropPictmetabitmapbpp,
 

    "line",     0,      fFalse,     kwdChar,    0x0d,
    "par",      0,      fFalse,     kwdChar,    0x0a,
    "row",      0,      fFalse,     kwdChar,    0x0d, // table fix row terminator new line
    "cell",     0,      fFalse,     kwdChar,    0x09, // table fix cell terminator tab
    "\0x0a",    0,      fFalse,     kwdChar,    0x0a,
    "\0x0d",    0,      fFalse,     kwdChar,    0x0a,
    "tab",      0,      fFalse,     kwdChar,    0x09,
    "ldblquote",0,      fFalse,     kwdChar,    '',
    "rdblquote",0,      fFalse,     kwdChar,    '',
    "lquote",   0,      fFalse,     kwdChar,    '',
    "rquote",   0,      fFalse,     kwdChar,    '',
    "~",        0,      fFalse,     kwdChar,    '', // nbsp
    "-",        0,      fFalse,     kwdChar,    0x15,// disc hyphen#
    "_",        0,      fFalse,     kwdChar,    0x16,// nb hyph
    "endash",   0,      fFalse,     kwdChar,    '', //
    "emdash",   0,      fFalse,     kwdChar,    '', //
    "enspace",  0,      fFalse,     kwdChar,    ' ', //
    "emspace",  0,      fFalse,     kwdChar,    ' ', //
    "page",     0,      fFalse,     kwdChar,    0x3, //
    "column",   0,      fFalse,     kwdChar,    0x2, //
    "bullet",   0,      fFalse,     kwdChar,    '', //
    "chdate",   0,      fFalse,     kwdChar,    0x5, // Current date (as in headers).
    "chdpl",    0,      fFalse,     kwdChar,    0x5, // Current date in long format (for example, Thursday, October 28, 1997).
    "chdpa",    0,      fFalse,     kwdChar,    0x5, // Current date in abbreviated format (for example, Thu, Oct 28, 1997).
    "chtime",   0,      fFalse,     kwdChar,    0x5, // Current time (as in headers).
    "chpgn",    0,      fFalse,     kwdChar,    0x1E,// Current page number (as in headers).
    "sectnum",  0,      fFalse,     kwdChar,    0x4, // Current section number (as in headers).
 

    "bin",      0,      fFalse,     kwdSpec,    ipfnBin,
    "*",        0,      fFalse,     kwdSpec,    ipfnSkipDest,
    "'",        0,      fFalse,     kwdSpec,    ipfnHex,
    "author",   0,      fFalse,     kwdDest,    idestSkip,
    "buptim",   0,      fFalse,     kwdDest,    idestSkip,
    "colortbl", 0,      fFalse,     kwdDest,    idestColour,
    "comment",  0,      fFalse,     kwdDest,    idestSkip,
    "creatim",  0,      fFalse,     kwdDest,    idestSkip,
    "doccomm",  0,      fFalse,     kwdDest,    idestSkip,
    "fonttbl",  0,      fFalse,     kwdDest,    idestFont,
    "footer",   0,      fFalse,     kwdDest,    idestSkip,
    "footerf",  0,      fFalse,     kwdDest,    idestSkip,
    "footerl",  0,      fFalse,     kwdDest,    idestSkip,
    "footerr",  0,      fFalse,     kwdDest,    idestSkip,
    "footnote", 0,      fFalse,     kwdDest,    idestSkip,
    "ftncn",    0,      fFalse,     kwdDest,    idestSkip,
    "ftnsep",   0,      fFalse,     kwdDest,    idestSkip,
    "ftnsepc",  0,      fFalse,     kwdDest,    idestSkip,
    "header",   0,      fFalse,     kwdDest,    idestSkip,
    "headerf",  0,      fFalse,     kwdDest,    idestSkip,
    "headerl",  0,      fFalse,     kwdDest,    idestSkip,
    "headerr",  0,      fFalse,     kwdDest,    idestSkip,
    "info",     0,      fFalse,     kwdDest,    idestSkip,
    "keycode",  0,      fFalse,     kwdDest,    idestKeyCode,
    "keywords", 0,      fFalse,     kwdDest,    idestSkip,
    "operator", 0,      fFalse,     kwdDest,    idestSkip,
    "pict",     0,      fFalse,     kwdDest,    idestPict,
    "printim",  0,      fFalse,     kwdDest,    idestSkip,
    "private1", 0,      fFalse,     kwdDest,    idestSkip,
    "revtim",   0,      fFalse,     kwdDest,    idestSkip,
    "rxe",      0,      fFalse,     kwdDest,    idestSkip,
    "stylesheet",0,     fFalse,     kwdDest,    idestStyleSheet,
    "subject",  0,      fFalse,     kwdDest,    idestSkip,
    "tc",       0,      fFalse,     kwdDest,    idestSkip,
    "title",    0,      fFalse,     kwdDest,    idestSkip,
    "txe",      0,      fFalse,     kwdDest,    idestSkip,
    "xe",       0,      fFalse,     kwdDest,    idestSkip,
    "{",        0,      fFalse,     kwdChar,    '{',
    "}",        0,      fFalse,     kwdChar,    '}',
    "\\",       0,      fFalse,     kwdChar,    '\\',
				"u",								0,						fFalse,					kwdChar,				0x8,
};


int isymMax = sizeof(rgsymRtf) / sizeof(SYM);



//
// %%Function: ecApplyPropChange
//
// Set the property identified by _iprop_ to the value _val_.
//
//

static int ecApplyPropChange(IPROP iprop,int val)
{
 char * pb;
 int  * abits;
 int    word;

 if(rds==rdsSkip) return ecOK; // If we're skipping text,
                               // don't do anything.

 if(rds==rdsNorm || rds==rdsStyle)
 {
  switch(rgprop[iprop].prop)
  {
     case propDop:
                  pb=(char *)&dop;
                  abits=dop.actionbits;
                  break;

     case propSep:
                  pb=(char *)&sep;
                  abits=dop.actionbits;
                  break;

     case propPap:
                  pb=(char *)&pap;
                  abits=dop.actionbits;
                  break;

     case propChp:
                  pb=(char *)&chp;
                  abits=dop.actionbits;
                  break;

          default:
                  if(rgprop[iprop].actn!=actnSpec)
                  {
                   return(ecBadTable);
                  }
                  break;
  }

    
  switch(rgprop[iprop].actn)
  {
    case actnByte:
                  pb[rgprop[iprop].offset]=(unsigned char)val;
                  word=rgprop[iprop].offset/32;
                  *(abits+word)=(*(abits+word)) | (1<<(rgprop[iprop].offset& 0x1F));
                  break;

    case actnWord:
                  (*(int *)(pb+rgprop[iprop].offset))=val;
                  word=rgprop[iprop].offset/32;
                  *(abits+word)=(*(abits+word)) | (1<<(rgprop[iprop].offset& 0x1F));
                  break;

    case actnSpec:
                  return(ecParseSpecialProperty(iprop,val));
                  break;

          default:
                  return(ecBadTable);
  }

  stylechange();
 }
 else
 if(rds==rdsFont)
 {
  if(iprop==ipropFont)
  {
   fonttablemember(val);
  }
 }
 else
 if(rds==rdsKeyCode)
 {
  keycodemember(iprop,val);
 }

 return(ecOK);
}




static int ecFont(IPROP iprop,int val)
{
 if(rds==rdsFont)
 {
  if(iprop==ipropFontFamily) fonttablefamily(val);
 }

 return(ecOK);
}




static int ecColour(IPROP iprop,int val)
{            
 if(rds==rdsColour)
 {
  colourtablevalue(iprop,val);
 }

 return(ecOK);
}



static int ecTabs(IPROP iprop,int val)
{            
 if(rds==rdsTabs)
 {
  tabsvalue(iprop,val);
 }

 return(ecOK);
}





static int ecStyle(IPROP iprop,int val)
{
 if(rds==rdsStyle)
 {
  styletablemember(iprop,val);
 }
 else
 if(rds==rdsNorm)
 {
  styleadd(iprop,val);
 }

 return(ecOK);
}






//
// %%Function: ecParseSpecialProperty
//
// Set a property that requires code to evaluate.
//


int ecParseSpecialProperty(IPROP iprop, int val)
{

 switch (iprop)
 {
    case ipropPard:
                   memset(&pap,0,sizeof(pap));
                   pap.just=justL;
                   stylerem(ipropPStyle);
                   return(ecOK);

   case ipropPlain:
                   memset(&chp,0,sizeof(chp));
                   chp.fontsize=24;
                   chp.font=deffont;
																			chp.unicoden=1;
                   stylerem(ipropCStyle);
                   return(ecOK);

   case ipropSectd:
                   memset(&sep,0,sizeof(sep));
                   stylerem(ipropSStyle);
                   return(ecOK);

           default:
                   return(ecBadTable);
 }

 return(ecBadTable);
}




//
// %%Function: ecTranslateKeyword.
//
// Step 3.
// Search rgsymRtf for szKeyword and evaluate it appropriately.
//
// Inputs:
// szKeyword:   The RTF control to evaluate.
// param:       The parameter of the RTF control.
// fParam:      fTrue if the control had a parameter; (that is, if param is valid)
//              fFalse if it did not.
//


int ecTranslateKeyword(char *szKeyword,int param,char fParam)
{
 int isym;
	int code;

// cprintf("kw %s",szKeyword);



 // search for szKeyword in rgsymRtf

 for(isym=0;isym<isymMax;isym++)
 {
  if(strcmp(szKeyword,rgsymRtf[isym].szKeyword)==0)
  {
   break;
  }
 }

 if(isym==isymMax)                // control word not found
 {
  if(fSkipDestIfUnk) rds=rdsSkip; // if this is a new destination
                                  // skip the destination
                                  // else just discard it
  fSkipDestIfUnk=fFalse;
  return(ecOK);
 }

 // found it!  use kwd and idx to determine what to do with it.

 fSkipDestIfUnk=fFalse;

 switch(rgsymRtf[isym].kwd)
 {
    case kwdProp:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecApplyPropChange((IPROP)rgsymRtf[isym].idx,param));

    case kwdChar:
																	code=ecParseChar(rgsymRtf[isym].idx,param);
																	if(rgsymRtf[isym].idx==0x8)
                	{
																		cprintf("uniskip %d",chp.unicoden);
                		unicodeskip=chp.unicoden;
                		if(unicodeskip)
                		{
		                 risUnicode=1;
		                }
	                }
                 return(code);

    case kwdDest:
                 return(ecChangeDest((IDEST)rgsymRtf[isym].idx));

    case kwdSpec:
                 return(ecParseSpecialKeyword((IPFN)rgsymRtf[isym].idx));

    case kwdFont:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecFont((IPROP)rgsymRtf[isym].idx,param));


    case kwdPict:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecPict((IPROP)rgsymRtf[isym].idx,param));


    case kwdStyle:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecStyle((IPROP)rgsymRtf[isym].idx,param));


  case kwdColour:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecColour((IPROP)rgsymRtf[isym].idx,param));

  case kwdSystem:
                 return(ecOK);

  case   kwdTabs:
                 if(rgsymRtf[isym].fPassDflt || !fParam)
                 {
                  param=rgsymRtf[isym].dflt;
                 }
                 return(ecTabs((IPROP)rgsymRtf[isym].idx,param));

         default:
                 return(ecBadTable);
 }

 return(ecBadTable);
}



//
// %%Function: ecChangeDest
//
// Change to the destination specified by idest.
// There's usually more to do here than this...
//


int ecChangeDest(IDEST idest)
{

 if(rds==rdsSkip) return(ecOK); // if we're skipping text,
                                // don't do anything

 switch(idest)
 {
      case idestColour:
                       rds=rdsColour;
                       colourtablestart();
                       break;

        case idestPict:
                       rds=rdsPict;
                       pictstart();
                       break;

        case idestFont:
                       rds=rdsFont;
                       fonttablestart();
                       break;

  case idestStyleSheet:
                       rds=rdsStyle;
                       styletablestart();
                       break;

     case idestKeyCode:
                       rds=rdsKeyCode;
                       keycodestart();
                       break;

        case	idestTabs:
																							rds=rdsTabs;
																							tabscodestart();
																							break;

               default:
                       rds=rdsSkip;              // when in doubt, skip it...
                       break;
 }

 return(ecOK);
}




//
// %%Function: ecEndGroupAction
//
// The destination specified by rds is coming to a close.
// If there's any cleanup that needs to be done, do it now.
//

int ecEndGroupAction(RDS rds)
{

// cprintf("end group %d %d",rds,idestPict);

 if(rds==rdsSkip) return(ecOK); // if we're skipping text,
                                // don't do anything

 switch(rds)
 {
      case rdsColour:
                       colourtableend();
                       break;

        case rdsPict:
                       pictend();
                       break;

        case rdsFont:
                       fonttableend();
                       break;

       case rdsStyle:
                       styletableend();
                       break;

     case rdsKeyCode:
                       keycodeend();
                       break;

		  				case	rdsTabs:
																							tabscodeend();
																							break;

 }

 return(ecOK);
}




//
// %%Function: ecParseSpecialKeyword
//
// Evaluate an RTF control that needs special processing.
//


int ecParseSpecialKeyword(IPFN ipfn)
{

 if(rds==rdsSkip && ipfn!=ipfnBin)  // if we're skipping, and it's not
        return(ecOK);                        // the \bin keyword, ignore it.

 switch (ipfn)
 {
       case ipfnBin:
                    ris=risBin;
                    cbBin=lParam;
                    break;

  case ipfnSkipDest:
                    fSkipDestIfUnk=fTrue;
                    break;

       case ipfnHex:
                    ris=risHex;
                    break;

            default:
                    return(ecBadTable);
 }

 return(ecOK);
}


